<template>
  <div>
    <InfoBox :title="title">
      <table class="w-full table-auto border-collapse">
        <tbody>
          <tr v-for="(item, index) in sortedStocks" :key="index">
            <td class="align-top" :class="{ 'pb-2': index < stocks.length - 1 }">
              {{ item.name }}
            </td>
            <td class="text-right align-top">
              <span class="block text-sm text-gray-700 dark:text-brand-white">
                {{ item.price | currency(item.currency) }}
              </span>
              <span class="block text-xs text-gray-400 mb-3 dark:text-brand-white">
                {{ item.timestamp | date }}
              </span>
            </td>
            <td class="text-right align-top">
              <DeltaIndicator :value-in-percent="item.differenceInPercent" />
            </td>
          </tr>
        </tbody>
      </table>
    </InfoBox>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { Stock } from '../types';

export default Vue.extend({
  props: {
    stocks: {
      type: Array,
      default: () => []
    },
    title: {
      type: String,
      required: true
    }
  },

  computed: {
    /**
     * Show the stock with the highest difference at the top most position.
     */
    sortedStocks (): Stock[] {
      return (this.stocks as Stock[])
        .map(stock => stock)
        .sort((a: Stock, b: Stock) => {
          return Math.abs(b.differenceInPercent) - Math.abs(a.differenceInPercent);
        });
    }
  }
});
</script>
